function varargout = Soundspectrum(varargin)
% Soundspectrum M-file for Soundspectrum.fig
% Makes a false color frequency plot of a wave file
%Ver 1.1  Fixed so it can read stereo file
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help Soundspectrum

% Last Modified by GUIDE v2.5 02-Nov-2011 15:44:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Soundspectrum_OpeningFcn, ...
                   'gui_OutputFcn',  @Soundspectrum_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Soundspectrum is made visible.
function Soundspectrum_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Soundspectrum (see VARARGIN)

% Choose default command line output for Soundspectrum
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Soundspectrum wait for user response (see UIRESUME)
% uiwait(handles.figure1);
global infile
infile=0;
ver ='Ver 1.1 01/13';
set(handles.Ver,'string',ver)

% --- Outputs from this function are returned to the command line.
function varargout = Soundspectrum_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on button press in GetFile -------------------
function GetFile_Callback(hObject, eventdata, handles)
global infile
global filename

%Read in wav file
%prompt for file name
    [filename pathname] = uigetfile('*.wav', 'Select Sound file for Frequency Analysis');
    file=[pathname filename];
    [infiletemp,SR,bits]=wavread(file);
%take only first column if stereo
    infile=infiletemp(:,1);
% Store sample rate in window
    SR=num2str(SR);
    set(handles.SampleRate, 'String', SR)
%calculate Soundspectrum
    sono(hObject,eventdata,handles)
%-------------------------------------------------------------

% --- Executes on button press in SetLimits.
function SetLimits_Callback(hObject, eventdata, handles)
% hObject    handle to SetLimits (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global infile

%Get limits of current axes
    s= get(handles.axes1, 'Xlim');
    xmin=s(1); xmax=s(2);
    s = get(handles.axes1, 'ylim');
    ymin=s(1); ymax=s(2);
%set up array for dialog box    
    default{1}=num2str(xmin);
    default{2}=num2str(xmax);
    default{3}=num2str(ymin);
    default{4}=num2str(ymax);
    string={'Xmin','Xmax','Ymin','Ymax'};
    reply=inputdlg(string,'Set Plot Limits',1,default);    
%get values
    xmin=str2num(reply{1});
    xmax=str2num(reply{2});
    ymin=str2num(reply{3});
    ymax=str2num(reply{4});
%Check that all values are numbers
    lim = [xmin xmax ymin ymax];
    notnum = isnan(lim);
    notnum = sum(notnum);
    if notnum
    %make error dialog
        h = errordlg( 'One of the limit values is not a number');
        uiwait(h)   
    else
        % update the axis
        axis(lim)
    end    

% --- Executes on selection change in SpectrumSize.
function SpectrumSize_Callback(hObject, eventdata, handles)
%calculate Soundspectrum
 global infile

[flag flag2] = size(infile);
if flag2 > 1
    % Calculate new Soundspectrum    
    sono(hObject,eventdata,handles)
end

% --- Executes on button press in Play.
function Play_Callback(hObject, eventdata, handles)
%Plays wav file
global infile
%get sample rate
SR=get(handles.SampleRate,'string');
SR=str2num(SR);
wavplay(infile,SR)

%---------------------------------------------------------------------

function sono(hObject,eventdata,handles)
% calculates and displays Soundspectrum
global infile
global filename

%get the Spectrum size from list box
    freq=get(handles.SpectrumSize,'String');    %Cell array of values
    choice=get(handles.SpectrumSize,'Value');   % Index of choice
    freq=freq(choice);
    freq=char(freq);
    freq=str2num(freq);
    hopsiz = freq;
    windsiz= 2*hopsiz;
% Read Sample rate from window
    SR=get(handles.SampleRate,'String');
    SR=str2num(SR);
%calculate nyquist frequency and resolution
    fnyq=SR/2;
    df=fnyq/hopsiz;
%update values in window
    set(handles.NyquistFreq,'String', num2str(fnyq))
    set(handles.Resolution, 'String', num2str(df))
% check for row in and make it a row if it's a column
    [rr cc] = size(infile);
if rr ~= 1 & cc ~= 1
   error('not a row or col array')
elseif  rr  ~= 1     % not an input row array
   infile = infile';
end

% resize the input matrix for fft
for ii = 1:(floor((length(infile) - windsiz))/hopsiz)+ 1
   nn = 1 + (ii-1)*hopsiz ;
   infile2(:,ii) = (infile(nn:nn+windsiz-1))';
end	

% %%%%%%%%%%%  put on a hamming filter window 
[rr cc] = size(infile2);
	nfrms = cc; 
 	hammWind = repmat(hamming2(windsiz) , 1, nfrms);
 	infile2 = hammWind .* infile2;
    fftox = fft(infile2); % take fft
    fftox = fftox(1:windsiz/2,:); %take only the 1st half

% takes mag of each column  
 	absfftox = abs(fftox)+ .001;
%Setup arrays for axis
    [row col] = size(fftox);
%calculate frequencies    
	ff = [0:windsiz-1]*SR/windsiz; %yaxis
	ff = ff(1:windsiz/2);
%calculate time    
	tim = [1:col]*hopsiz/SR; %x-axis

%display image
%convert coefficients into decibels
    db=20*log10(absfftox);
    imagesc(tim, ff, db); axis xy
    xlabel('Time (sec)')
    ylabel('Frequency (Hz)')
    title(filename)
    colorbar
%---------------------------------end sono ---------------------------

%Hamming function for pre fft analysis
function outwin = hamming2(windin);
    outwin = .5 - .5 * cos([0:(windin-1)]*2*pi/windin);
    outwin = outwin';
